//+------------------------------------------------------------------+ 
// #Chaos RSIOMA              \/
// Knowledge of the ancients ( )
//______________________o0o___(_)___o0o_____
//___Xard777__________________________       17th October 2009
//+------------------------------------------------------------------+
//+--------------------------------------------------------------------------------+
//|      RSIOMA_v3   by  Mladen  &  fxbs       Kalenzo              | fxtsd.com |ik|
//|  Hornet(RSIOnArray)  2007, FxTSD.com       MetaQuotes Software Corp.           |
//|  Hist & Levels 20/80;30/70  CrossSig       web: http://www.fxservice.eu        |
//|  Rsioma/MaRsioma X sig ()                  email: bartlomiej.gorski@gmail.com  |
//+--------------------------------------------------------------------------------+

//#property copyright "Copyright  2007, MetaQuotes Software Corp."
//#property link      "http://www.metaquotes.net/ Kalenzo|bartlomiej.gorski@gmail.com "
#property indicator_separate_window
#property indicator_buffers   8
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_color1     CLR_NONE//Lime
#property indicator_color2     CLR_NONE//Red
#property indicator_color3     CLR_NONE//Blue
#property indicator_color4     CLR_NONE
#property indicator_color5     CLR_NONE
#property indicator_color6     CLR_NONE//Red//BlueViolet
#property indicator_color7     CLR_NONE//SteelBlue//DeepSkyBlue
#property indicator_color8     CLR_NONE//HotPink//Sienna //Crimson
//
#property indicator_width1  3
#property indicator_width2  2
#property indicator_width3  2   
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  0
#property indicator_width8  0

#property indicator_levelcolor White
#property indicator_levelstyle 2

extern bool show.line.data=true;

extern int    RSIOMA          = 21;//7;
extern int    RSIOMA_MODE     = MODE_LWMA;
extern int    RSIOMA_PRICE    = PRICE_MEDIAN;
extern int    Ma_RSIOMA       = 0;//21;
extern int    Ma_RSIOMA_MODE  = MODE_LWMA;

double BuyTrigger          = 10;
double SellTrigger         = 90;
color  BuyTriggerColor     = CLR_NONE;//Magenta;
color  SellTriggerColor    = CLR_NONE;//Magenta;

double MainTrendLong       = 20;
double MainTrendShort      = 80;
color  MainTrendLongColor  = CLR_NONE;//DodgerBlue;
color  MainTrendShortColor = CLR_NONE;//DodgerBlue;
double MajorTrend          = 50;
color  marsiomaXupSigColor = CLR_NONE;//Lime;//DeepSkyBlue
color  marsiomaXdnSigColor = CLR_NONE;//DeepPink; //Crimson


double MainTrend50       = 50;
color  MainTrend50Color  = CLR_NONE;//DimGray;


int    BarsToCount         = 5000;

double MABuffer1[];
double RSIBuffer1[];

double RSIBuffer[];
double bdn[];
double bup[];
double sdn[];
double sup[];
double marsioma[];
double marsiomaXupSig[];
double marsiomaXdnSig[];

int      correction;
datetime lastBarTime;
string   short_name;
//string pstring, ltext;
//int psize;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   short_name = " ";//(",Ma_RSIOMA,")");   
   IndicatorShortName(short_name);
   
   SetIndexBuffer(0,RSIBuffer);
   SetIndexBuffer(2,bup);
   SetIndexBuffer(1,bdn);
   SetIndexBuffer(3,sdn);//Magneta
   SetIndexBuffer(4,sup);//DodgerBlue
   SetIndexBuffer(5,marsioma);
   SetIndexBuffer(6,marsiomaXupSig);
   SetIndexBuffer(7,marsiomaXdnSig);

      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(6,DRAW_NONE);
         SetIndexArrow(6,92);//159
      SetIndexStyle(7,DRAW_NONE);
         SetIndexArrow(7,94);//159
  
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);

      correction  = RSIOMA+RSIOMA+Ma_RSIOMA;
      BarsToCount = MathMin(Bars,MathMax(BarsToCount,300));
          ArrayResize( MABuffer1 ,BarsToCount+correction);
          ArrayResize( RSIBuffer1,BarsToCount+correction);
          ArraySetAsSeries(MABuffer1 ,true);
          ArraySetAsSeries(RSIBuffer1,true);
                 lastBarTime = EMPTY_VALUE;


   return(0);
}


//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("rtx");
//----
   return(0);
  }
//+------------------------------------------------------------------+

int start()
{
   static bool init=false;
   int    counted_bars=IndicatorCounted();
   int    limit,i=0;

   if(!init) {
       init=true;
         drawLine(BuyTrigger,"BuyTrigger", BuyTriggerColor);
         drawLine(SellTrigger,"SellTrigger", SellTriggerColor );
         drawLine(MainTrendLong,"MainTrendLong", MainTrendLongColor );
         drawLine(MainTrendShort,"MainTrendShort",MainTrendShortColor );
         drawLine(MainTrend50,"MainTrend50", MainTrend50Color );
               }         
                    
   if(counted_bars<0) return(-1);
   if(lastBarTime != Time[0]) {
      lastBarTime  = Time[0];
                  counted_bars = 0;
      }         
      if(counted_bars>0) counted_bars--;
              limit=Bars-counted_bars;
              limit=MathMin(limit,BarsToCount+correction);
   
      for(i=limit;i>=0;i--) 
   MABuffer1[i]  = iMA(Symbol(),0,RSIOMA,0,RSIOMA_MODE,RSIOMA_PRICE,i);
      for(i=limit;i>=0;i--) 
   RSIBuffer1[i] = iRSIOnArray(MABuffer1,0,RSIOMA,i);
      for(i=limit;i>=0;i--)
      {
   RSIBuffer[i]= RSIBuffer1[i];
   marsioma[i] = iMAOnArray(RSIBuffer1,0,Ma_RSIOMA,0,Ma_RSIOMA_MODE,i); 
         
  
            bup[i] = EMPTY_VALUE; bdn[i] = EMPTY_VALUE;
            sup[i] = EMPTY_VALUE; sdn[i] = EMPTY_VALUE;
            
               if(RSIBuffer[i] > 50)               bup[i] =   6;
               if(RSIBuffer[i] < 50)               bdn[i] =  -6;      
               if(RSIBuffer[i] > MainTrendLong)    bup[i] =  12;
               if(RSIBuffer[i] < MainTrendShort)   bdn[i] = -12;
            
               if(RSIBuffer[i]<20 && RSIBuffer[i]>RSIBuffer[i+1])                sup[i] =  -3;
               if(RSIBuffer[i]>80 && RSIBuffer[i]<RSIBuffer[i+1])                sdn[i] =   4;
               if(RSIBuffer[i]>20 && RSIBuffer[i+1]<=20)                         sup[i] =   5;
               if(RSIBuffer[i+1]>=80 && RSIBuffer[i]<80)                         sdn[i] =  -5;
               if(RSIBuffer[i+1]<=MainTrendShort && RSIBuffer[i]>MainTrendShort) sup[i] =  12;  
               if(RSIBuffer[i]<MainTrendLong && RSIBuffer[i+1]>=MainTrendLong)   sdn[i] = -12;

            marsiomaXupSig[i] = EMPTY_VALUE;
            marsiomaXdnSig[i] = EMPTY_VALUE;
            
               if(RSIBuffer[i+1]<=marsioma[i+1]&&RSIBuffer[i]>marsioma[i]) marsiomaXupSig[i] = -11; 
               if(RSIBuffer[i+1]>=marsioma[i+1]&&RSIBuffer[i]<marsioma[i]) marsiomaXdnSig[i] =  11;
  
if (show.line.data) {  
      ////////////////////////////
      ObjectDelete("rtx");
      ObjectCreate("rtx", OBJ_LABEL, 1, 0, 0);
      ObjectSetText("rtx", "RSI: "+DoubleToStr(RSIBuffer[i],2), 16, "Arial", Lime);
      ObjectSet("rtx", OBJPROP_CORNER, 0);
      ObjectSet("rtx", OBJPROP_BACK, false);
      ObjectSet("rtx", OBJPROP_XDISTANCE, 363);
      ObjectSet("rtx", OBJPROP_YDISTANCE, 5);
      /////////////////////////////////////////
}

   }

   
   for (i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Bars-BarsToCount);
 
   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void drawLine(double lvl,string name, color Col )
{
   ObjectDelete(name);
   ObjectCreate(name, OBJ_HLINE, 1, Time[0], lvl,Time[0], lvl);
   ObjectSet(name   , OBJPROP_STYLE, STYLE_DOT);
   ObjectSet(name   , OBJPROP_COLOR, Col);
   ObjectSet(name   , OBJPROP_BACK, true);         
   ObjectSet(name   , OBJPROP_WIDTH, 1);
}


